# coding: utf-8

# flake8: noqa

"""
    Seller API Analytics

    **The service provides a public API for obtaining analytical data.**  Analytical data in the source is stored for the past year. When selecting a start date earlier than a year ago, an error will be returned, so the maximum number of days in aggregations is 365.  Also, in the data where information about the previous period is provided: 1. In `previousPeriod`, the data is for the same period as in `selectedPeriod`. 2. If the start date of `previousPeriod` is earlier than a year ago from the current date, it will be adjusted as follows:  `previousPeriod.start = current date - 365 days.`  #### Time Zones  IANA format, the current list can be viewed [here](https://nodatime.org/TimeZones). <br> <br> <br>   # noqa: E501

    OpenAPI spec version: 2.18
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

# import apis into sdk package
from wildberries_api_client.analytics.api.deductions_api import DeductionsApi
from wildberries_api_client.analytics.api.paid_storage_api import PaidStorageApi
from wildberries_api_client.analytics.api.products_with_mandatory_labeling_api import ProductsWithMandatoryLabelingApi
from wildberries_api_client.analytics.api.sales_funnel_api import SalesFunnelApi
# import ApiClient
from wildberries_api_client.analytics.api_client import ApiClient
from wildberries_api_client.analytics.configuration import Configuration
# import models into sdk package
from wildberries_api_client.analytics.models.create_task_request import CreateTaskRequest
from wildberries_api_client.analytics.models.create_task_response import CreateTaskResponse
from wildberries_api_client.analytics.models.create_task_response_data import CreateTaskResponseData
from wildberries_api_client.analytics.models.error_response import ErrorResponse
from wildberries_api_client.analytics.models.excise_report_request import ExciseReportRequest
from wildberries_api_client.analytics.models.excise_report_response import ExciseReportResponse
from wildberries_api_client.analytics.models.get_tasks_request import GetTasksRequest
from wildberries_api_client.analytics.models.get_tasks_response import GetTasksResponse
from wildberries_api_client.analytics.models.get_tasks_response_bytes_error import GetTasksResponseBytesError
from wildberries_api_client.analytics.models.get_tasks_response_bytes_error_data import GetTasksResponseBytesErrorData
from wildberries_api_client.analytics.models.get_tasks_response_bytes_error_data_tasks import GetTasksResponseBytesErrorDataTasks
from wildberries_api_client.analytics.models.get_tasks_response_data import GetTasksResponseData
from wildberries_api_client.analytics.models.inline_response200 import InlineResponse200
from wildberries_api_client.analytics.models.inline_response200_details import InlineResponse200Details
from wildberries_api_client.analytics.models.models_excise_report_response import ModelsExciseReportResponse
from wildberries_api_client.analytics.models.models_excise_report_response_data import ModelsExciseReportResponseData
from wildberries_api_client.analytics.models.models_excise_report_response_data_inner import ModelsExciseReportResponseDataInner
from wildberries_api_client.analytics.models.nm_report_detail_history_request import NmReportDetailHistoryRequest
from wildberries_api_client.analytics.models.nm_report_detail_history_request_period import NmReportDetailHistoryRequestPeriod
from wildberries_api_client.analytics.models.nm_report_detail_history_response import NmReportDetailHistoryResponse
from wildberries_api_client.analytics.models.nm_report_detail_history_response_data import NmReportDetailHistoryResponseData
from wildberries_api_client.analytics.models.nm_report_detail_history_response_history import NmReportDetailHistoryResponseHistory
from wildberries_api_client.analytics.models.nm_report_detail_request import NmReportDetailRequest
from wildberries_api_client.analytics.models.nm_report_detail_request_order_by import NmReportDetailRequestOrderBy
from wildberries_api_client.analytics.models.nm_report_detail_request_period import NmReportDetailRequestPeriod
from wildberries_api_client.analytics.models.nm_report_detail_response import NmReportDetailResponse
from wildberries_api_client.analytics.models.nm_report_detail_response_additional_errors import NmReportDetailResponseAdditionalErrors
from wildberries_api_client.analytics.models.nm_report_detail_response_data import NmReportDetailResponseData
from wildberries_api_client.analytics.models.nm_report_detail_response_data_cards import NmReportDetailResponseDataCards
from wildberries_api_client.analytics.models.nm_report_detail_response_data_object import NmReportDetailResponseDataObject
from wildberries_api_client.analytics.models.nm_report_detail_response_data_object_period_comparison import NmReportDetailResponseDataObjectPeriodComparison
from wildberries_api_client.analytics.models.nm_report_detail_response_data_object_period_comparison_conversions import NmReportDetailResponseDataObjectPeriodComparisonConversions
from wildberries_api_client.analytics.models.nm_report_detail_response_data_object_previous_period import NmReportDetailResponseDataObjectPreviousPeriod
from wildberries_api_client.analytics.models.nm_report_detail_response_data_object_previous_period_conversions import NmReportDetailResponseDataObjectPreviousPeriodConversions
from wildberries_api_client.analytics.models.nm_report_detail_response_data_object_statistics import NmReportDetailResponseDataObjectStatistics
from wildberries_api_client.analytics.models.nm_report_detail_response_data_object_statistics_selected_period import NmReportDetailResponseDataObjectStatisticsSelectedPeriod
from wildberries_api_client.analytics.models.nm_report_detail_response_data_object_statistics_selected_period_conversions import NmReportDetailResponseDataObjectStatisticsSelectedPeriodConversions
from wildberries_api_client.analytics.models.nm_report_detail_response_data_stocks import NmReportDetailResponseDataStocks
from wildberries_api_client.analytics.models.nm_report_detail_response_data_tags import NmReportDetailResponseDataTags
from wildberries_api_client.analytics.models.nm_report_grouped_history_request import NmReportGroupedHistoryRequest
from wildberries_api_client.analytics.models.nm_report_grouped_history_request_period import NmReportGroupedHistoryRequestPeriod
from wildberries_api_client.analytics.models.nm_report_grouped_history_response import NmReportGroupedHistoryResponse
from wildberries_api_client.analytics.models.nm_report_grouped_history_response_data import NmReportGroupedHistoryResponseData
from wildberries_api_client.analytics.models.nm_report_grouped_history_response_history import NmReportGroupedHistoryResponseHistory
from wildberries_api_client.analytics.models.nm_report_grouped_history_response_object import NmReportGroupedHistoryResponseObject
from wildberries_api_client.analytics.models.nm_report_grouped_history_response_tag import NmReportGroupedHistoryResponseTag
from wildberries_api_client.analytics.models.nm_report_grouped_request import NmReportGroupedRequest
from wildberries_api_client.analytics.models.nm_report_grouped_request_order_by import NmReportGroupedRequestOrderBy
from wildberries_api_client.analytics.models.nm_report_grouped_request_period import NmReportGroupedRequestPeriod
from wildberries_api_client.analytics.models.nm_report_grouped_response import NmReportGroupedResponse
from wildberries_api_client.analytics.models.nm_report_grouped_response_data import NmReportGroupedResponseData
from wildberries_api_client.analytics.models.nm_report_grouped_response_data_groups import NmReportGroupedResponseDataGroups
from wildberries_api_client.analytics.models.nm_report_grouped_response_data_object import NmReportGroupedResponseDataObject
from wildberries_api_client.analytics.models.nm_report_grouped_response_data_period_comparison import NmReportGroupedResponseDataPeriodComparison
from wildberries_api_client.analytics.models.nm_report_grouped_response_data_period_comparison_conversions import NmReportGroupedResponseDataPeriodComparisonConversions
from wildberries_api_client.analytics.models.nm_report_grouped_response_data_statistics import NmReportGroupedResponseDataStatistics
from wildberries_api_client.analytics.models.nm_report_grouped_response_data_statistics_previous_period import NmReportGroupedResponseDataStatisticsPreviousPeriod
from wildberries_api_client.analytics.models.nm_report_grouped_response_data_statistics_previous_period_conversions import NmReportGroupedResponseDataStatisticsPreviousPeriodConversions
from wildberries_api_client.analytics.models.nm_report_grouped_response_data_statistics_selected_period import NmReportGroupedResponseDataStatisticsSelectedPeriod
from wildberries_api_client.analytics.models.nm_report_grouped_response_data_statistics_selected_period_conversions import NmReportGroupedResponseDataStatisticsSelectedPeriodConversions
from wildberries_api_client.analytics.models.one_of_create_task_request import OneOfCreateTaskRequest
from wildberries_api_client.analytics.models.response_body_content_error400 import ResponseBodyContentError400
from wildberries_api_client.analytics.models.response_body_content_error400_additional_errors import ResponseBodyContentError400AdditionalErrors
from wildberries_api_client.analytics.models.response_body_content_error403 import ResponseBodyContentError403
from wildberries_api_client.analytics.models.response_error import ResponseError
from wildberries_api_client.analytics.models.response_paid_storage import ResponsePaidStorage
from wildberries_api_client.analytics.models.response_paid_storage_inner import ResponsePaidStorageInner
