# coding: utf-8

"""
    Seller API Analytics

    **The service provides a public API for obtaining analytical data.**  Analytical data in the source is stored for the past year. When selecting a start date earlier than a year ago, an error will be returned, so the maximum number of days in aggregations is 365.  Also, in the data where information about the previous period is provided: 1. In `previousPeriod`, the data is for the same period as in `selectedPeriod`. 2. If the start date of `previousPeriod` is earlier than a year ago from the current date, it will be adjusted as follows:  `previousPeriod.start = current date - 365 days.`  #### Time Zones  IANA format, the current list can be viewed [here](https://nodatime.org/TimeZones). <br> <br> <br>   # noqa: E501

    OpenAPI spec version: 2.18
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NmReportDetailHistoryResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'data': 'list[NmReportDetailHistoryResponseData]',
        'error': 'bool',
        'error_text': 'str',
        'additional_errors': 'list[NmReportDetailResponseAdditionalErrors]'
    }

    attribute_map = {
        'data': 'data',
        'error': 'error',
        'error_text': 'errorText',
        'additional_errors': 'additionalErrors'
    }

    def __init__(self, data=None, error=None, error_text=None, additional_errors=None):  # noqa: E501
        """NmReportDetailHistoryResponse - a model defined in Swagger"""  # noqa: E501
        self._data = None
        self._error = None
        self._error_text = None
        self._additional_errors = None
        self.discriminator = None
        if data is not None:
            self.data = data
        if error is not None:
            self.error = error
        if error_text is not None:
            self.error_text = error_text
        if additional_errors is not None:
            self.additional_errors = additional_errors

    @property
    def data(self):
        """Gets the data of this NmReportDetailHistoryResponse.  # noqa: E501


        :return: The data of this NmReportDetailHistoryResponse.  # noqa: E501
        :rtype: list[NmReportDetailHistoryResponseData]
        """
        return self._data

    @data.setter
    def data(self, data):
        """Sets the data of this NmReportDetailHistoryResponse.


        :param data: The data of this NmReportDetailHistoryResponse.  # noqa: E501
        :type: list[NmReportDetailHistoryResponseData]
        """

        self._data = data

    @property
    def error(self):
        """Gets the error of this NmReportDetailHistoryResponse.  # noqa: E501

        Error flag  # noqa: E501

        :return: The error of this NmReportDetailHistoryResponse.  # noqa: E501
        :rtype: bool
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this NmReportDetailHistoryResponse.

        Error flag  # noqa: E501

        :param error: The error of this NmReportDetailHistoryResponse.  # noqa: E501
        :type: bool
        """

        self._error = error

    @property
    def error_text(self):
        """Gets the error_text of this NmReportDetailHistoryResponse.  # noqa: E501

        Error description  # noqa: E501

        :return: The error_text of this NmReportDetailHistoryResponse.  # noqa: E501
        :rtype: str
        """
        return self._error_text

    @error_text.setter
    def error_text(self, error_text):
        """Sets the error_text of this NmReportDetailHistoryResponse.

        Error description  # noqa: E501

        :param error_text: The error_text of this NmReportDetailHistoryResponse.  # noqa: E501
        :type: str
        """

        self._error_text = error_text

    @property
    def additional_errors(self):
        """Gets the additional_errors of this NmReportDetailHistoryResponse.  # noqa: E501

        Additional errors  # noqa: E501

        :return: The additional_errors of this NmReportDetailHistoryResponse.  # noqa: E501
        :rtype: list[NmReportDetailResponseAdditionalErrors]
        """
        return self._additional_errors

    @additional_errors.setter
    def additional_errors(self, additional_errors):
        """Sets the additional_errors of this NmReportDetailHistoryResponse.

        Additional errors  # noqa: E501

        :param additional_errors: The additional_errors of this NmReportDetailHistoryResponse.  # noqa: E501
        :type: list[NmReportDetailResponseAdditionalErrors]
        """

        self._additional_errors = additional_errors

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NmReportDetailHistoryResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NmReportDetailHistoryResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
