# coding: utf-8

"""
    Seller API Analytics

    **The service provides a public API for obtaining analytical data.**  Analytical data in the source is stored for the past year. When selecting a start date earlier than a year ago, an error will be returned, so the maximum number of days in aggregations is 365.  Also, in the data where information about the previous period is provided: 1. In `previousPeriod`, the data is for the same period as in `selectedPeriod`. 2. If the start date of `previousPeriod` is earlier than a year ago from the current date, it will be adjusted as follows:  `previousPeriod.start = current date - 365 days.`  #### Time Zones  IANA format, the current list can be viewed [here](https://nodatime.org/TimeZones). <br> <br> <br>   # noqa: E501

    OpenAPI spec version: 2.18
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NmReportDetailHistoryResponseData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'nm_id': 'int',
        'imt_name': 'str',
        'vendor_code': 'str',
        'history': 'list[NmReportDetailHistoryResponseHistory]'
    }

    attribute_map = {
        'nm_id': 'nmID',
        'imt_name': 'imtName',
        'vendor_code': 'vendorCode',
        'history': 'history'
    }

    def __init__(self, nm_id=None, imt_name=None, vendor_code=None, history=None):  # noqa: E501
        """NmReportDetailHistoryResponseData - a model defined in Swagger"""  # noqa: E501
        self._nm_id = None
        self._imt_name = None
        self._vendor_code = None
        self._history = None
        self.discriminator = None
        if nm_id is not None:
            self.nm_id = nm_id
        if imt_name is not None:
            self.imt_name = imt_name
        if vendor_code is not None:
            self.vendor_code = vendor_code
        if history is not None:
            self.history = history

    @property
    def nm_id(self):
        """Gets the nm_id of this NmReportDetailHistoryResponseData.  # noqa: E501

        WB article  # noqa: E501

        :return: The nm_id of this NmReportDetailHistoryResponseData.  # noqa: E501
        :rtype: int
        """
        return self._nm_id

    @nm_id.setter
    def nm_id(self, nm_id):
        """Sets the nm_id of this NmReportDetailHistoryResponseData.

        WB article  # noqa: E501

        :param nm_id: The nm_id of this NmReportDetailHistoryResponseData.  # noqa: E501
        :type: int
        """

        self._nm_id = nm_id

    @property
    def imt_name(self):
        """Gets the imt_name of this NmReportDetailHistoryResponseData.  # noqa: E501

        Product Name  # noqa: E501

        :return: The imt_name of this NmReportDetailHistoryResponseData.  # noqa: E501
        :rtype: str
        """
        return self._imt_name

    @imt_name.setter
    def imt_name(self, imt_name):
        """Sets the imt_name of this NmReportDetailHistoryResponseData.

        Product Name  # noqa: E501

        :param imt_name: The imt_name of this NmReportDetailHistoryResponseData.  # noqa: E501
        :type: str
        """

        self._imt_name = imt_name

    @property
    def vendor_code(self):
        """Gets the vendor_code of this NmReportDetailHistoryResponseData.  # noqa: E501

        Vendor SKU  # noqa: E501

        :return: The vendor_code of this NmReportDetailHistoryResponseData.  # noqa: E501
        :rtype: str
        """
        return self._vendor_code

    @vendor_code.setter
    def vendor_code(self, vendor_code):
        """Sets the vendor_code of this NmReportDetailHistoryResponseData.

        Vendor SKU  # noqa: E501

        :param vendor_code: The vendor_code of this NmReportDetailHistoryResponseData.  # noqa: E501
        :type: str
        """

        self._vendor_code = vendor_code

    @property
    def history(self):
        """Gets the history of this NmReportDetailHistoryResponseData.  # noqa: E501


        :return: The history of this NmReportDetailHistoryResponseData.  # noqa: E501
        :rtype: list[NmReportDetailHistoryResponseHistory]
        """
        return self._history

    @history.setter
    def history(self, history):
        """Sets the history of this NmReportDetailHistoryResponseData.


        :param history: The history of this NmReportDetailHistoryResponseData.  # noqa: E501
        :type: list[NmReportDetailHistoryResponseHistory]
        """

        self._history = history

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NmReportDetailHistoryResponseData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NmReportDetailHistoryResponseData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
