# coding: utf-8

"""
    Seller API Analytics

    **The service provides a public API for obtaining analytical data.**  Analytical data in the source is stored for the past year. When selecting a start date earlier than a year ago, an error will be returned, so the maximum number of days in aggregations is 365.  Also, in the data where information about the previous period is provided: 1. In `previousPeriod`, the data is for the same period as in `selectedPeriod`. 2. If the start date of `previousPeriod` is earlier than a year ago from the current date, it will be adjusted as follows:  `previousPeriod.start = current date - 365 days.`  #### Time Zones  IANA format, the current list can be viewed [here](https://nodatime.org/TimeZones). <br> <br> <br>   # noqa: E501

    OpenAPI spec version: 2.18
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NmReportDetailResponseDataStocks(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'stocks_mp': 'int',
        'stocks_wb': 'int'
    }

    attribute_map = {
        'stocks_mp': 'stocksMp',
        'stocks_wb': 'stocksWb'
    }

    def __init__(self, stocks_mp=None, stocks_wb=None):  # noqa: E501
        """NmReportDetailResponseDataStocks - a model defined in Swagger"""  # noqa: E501
        self._stocks_mp = None
        self._stocks_wb = None
        self.discriminator = None
        if stocks_mp is not None:
            self.stocks_mp = stocks_mp
        if stocks_wb is not None:
            self.stocks_wb = stocks_wb

    @property
    def stocks_mp(self):
        """Gets the stocks_mp of this NmReportDetailResponseDataStocks.  # noqa: E501

        MP Inventory, units (Total quantity of inventory at the seller's warehouse)  # noqa: E501

        :return: The stocks_mp of this NmReportDetailResponseDataStocks.  # noqa: E501
        :rtype: int
        """
        return self._stocks_mp

    @stocks_mp.setter
    def stocks_mp(self, stocks_mp):
        """Sets the stocks_mp of this NmReportDetailResponseDataStocks.

        MP Inventory, units (Total quantity of inventory at the seller's warehouse)  # noqa: E501

        :param stocks_mp: The stocks_mp of this NmReportDetailResponseDataStocks.  # noqa: E501
        :type: int
        """

        self._stocks_mp = stocks_mp

    @property
    def stocks_wb(self):
        """Gets the stocks_wb of this NmReportDetailResponseDataStocks.  # noqa: E501

        Wildberries Warehouse Inventory (Total quantity of inventory at Wildberries warehouses)  # noqa: E501

        :return: The stocks_wb of this NmReportDetailResponseDataStocks.  # noqa: E501
        :rtype: int
        """
        return self._stocks_wb

    @stocks_wb.setter
    def stocks_wb(self, stocks_wb):
        """Sets the stocks_wb of this NmReportDetailResponseDataStocks.

        Wildberries Warehouse Inventory (Total quantity of inventory at Wildberries warehouses)  # noqa: E501

        :param stocks_wb: The stocks_wb of this NmReportDetailResponseDataStocks.  # noqa: E501
        :type: int
        """

        self._stocks_wb = stocks_wb

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NmReportDetailResponseDataStocks, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NmReportDetailResponseDataStocks):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
