# coding: utf-8

"""
    Seller API Analytics

    **The service provides a public API for obtaining analytical data.**  Analytical data in the source is stored for the past year. When selecting a start date earlier than a year ago, an error will be returned, so the maximum number of days in aggregations is 365.  Also, in the data where information about the previous period is provided: 1. In `previousPeriod`, the data is for the same period as in `selectedPeriod`. 2. If the start date of `previousPeriod` is earlier than a year ago from the current date, it will be adjusted as follows:  `previousPeriod.start = current date - 365 days.`  #### Time Zones  IANA format, the current list can be viewed [here](https://nodatime.org/TimeZones). <br> <br> <br>   # noqa: E501

    OpenAPI spec version: 2.18
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NmReportGroupedHistoryRequestPeriod(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'begin': 'date',
        'end': 'date'
    }

    attribute_map = {
        'begin': 'begin',
        'end': 'end'
    }

    def __init__(self, begin=None, end=None):  # noqa: E501
        """NmReportGroupedHistoryRequestPeriod - a model defined in Swagger"""  # noqa: E501
        self._begin = None
        self._end = None
        self.discriminator = None
        if begin is not None:
            self.begin = begin
        if end is not None:
            self.end = end

    @property
    def begin(self):
        """Gets the begin of this NmReportGroupedHistoryRequestPeriod.  # noqa: E501

        Start of the Period  # noqa: E501

        :return: The begin of this NmReportGroupedHistoryRequestPeriod.  # noqa: E501
        :rtype: date
        """
        return self._begin

    @begin.setter
    def begin(self, begin):
        """Sets the begin of this NmReportGroupedHistoryRequestPeriod.

        Start of the Period  # noqa: E501

        :param begin: The begin of this NmReportGroupedHistoryRequestPeriod.  # noqa: E501
        :type: date
        """

        self._begin = begin

    @property
    def end(self):
        """Gets the end of this NmReportGroupedHistoryRequestPeriod.  # noqa: E501

        End of the Period  # noqa: E501

        :return: The end of this NmReportGroupedHistoryRequestPeriod.  # noqa: E501
        :rtype: date
        """
        return self._end

    @end.setter
    def end(self, end):
        """Sets the end of this NmReportGroupedHistoryRequestPeriod.

        End of the Period  # noqa: E501

        :param end: The end of this NmReportGroupedHistoryRequestPeriod.  # noqa: E501
        :type: date
        """

        self._end = end

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NmReportGroupedHistoryRequestPeriod, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NmReportGroupedHistoryRequestPeriod):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
