# coding: utf-8

"""
    Seller API Analytics

    **The service provides a public API for obtaining analytical data.**  Analytical data in the source is stored for the past year. When selecting a start date earlier than a year ago, an error will be returned, so the maximum number of days in aggregations is 365.  Also, in the data where information about the previous period is provided: 1. In `previousPeriod`, the data is for the same period as in `selectedPeriod`. 2. If the start date of `previousPeriod` is earlier than a year ago from the current date, it will be adjusted as follows:  `previousPeriod.start = current date - 365 days.`  #### Time Zones  IANA format, the current list can be viewed [here](https://nodatime.org/TimeZones). <br> <br> <br>   # noqa: E501

    OpenAPI spec version: 2.18
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NmReportGroupedResponseData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'page': 'int',
        'is_next_page': 'bool',
        'groups': 'list[NmReportGroupedResponseDataGroups]'
    }

    attribute_map = {
        'page': 'page',
        'is_next_page': 'isNextPage',
        'groups': 'groups'
    }

    def __init__(self, page=None, is_next_page=None, groups=None):  # noqa: E501
        """NmReportGroupedResponseData - a model defined in Swagger"""  # noqa: E501
        self._page = None
        self._is_next_page = None
        self._groups = None
        self.discriminator = None
        if page is not None:
            self.page = page
        if is_next_page is not None:
            self.is_next_page = is_next_page
        if groups is not None:
            self.groups = groups

    @property
    def page(self):
        """Gets the page of this NmReportGroupedResponseData.  # noqa: E501

        Page  # noqa: E501

        :return: The page of this NmReportGroupedResponseData.  # noqa: E501
        :rtype: int
        """
        return self._page

    @page.setter
    def page(self, page):
        """Sets the page of this NmReportGroupedResponseData.

        Page  # noqa: E501

        :param page: The page of this NmReportGroupedResponseData.  # noqa: E501
        :type: int
        """

        self._page = page

    @property
    def is_next_page(self):
        """Gets the is_next_page of this NmReportGroupedResponseData.  # noqa: E501

        Is there a next page (false - no, true - yes)?  # noqa: E501

        :return: The is_next_page of this NmReportGroupedResponseData.  # noqa: E501
        :rtype: bool
        """
        return self._is_next_page

    @is_next_page.setter
    def is_next_page(self, is_next_page):
        """Sets the is_next_page of this NmReportGroupedResponseData.

        Is there a next page (false - no, true - yes)?  # noqa: E501

        :param is_next_page: The is_next_page of this NmReportGroupedResponseData.  # noqa: E501
        :type: bool
        """

        self._is_next_page = is_next_page

    @property
    def groups(self):
        """Gets the groups of this NmReportGroupedResponseData.  # noqa: E501


        :return: The groups of this NmReportGroupedResponseData.  # noqa: E501
        :rtype: list[NmReportGroupedResponseDataGroups]
        """
        return self._groups

    @groups.setter
    def groups(self, groups):
        """Sets the groups of this NmReportGroupedResponseData.


        :param groups: The groups of this NmReportGroupedResponseData.  # noqa: E501
        :type: list[NmReportGroupedResponseDataGroups]
        """

        self._groups = groups

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NmReportGroupedResponseData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NmReportGroupedResponseData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
