# coding: utf-8

"""
    Seller API Analytics

    **The service provides a public API for obtaining analytical data.**  Analytical data in the source is stored for the past year. When selecting a start date earlier than a year ago, an error will be returned, so the maximum number of days in aggregations is 365.  Also, in the data where information about the previous period is provided: 1. In `previousPeriod`, the data is for the same period as in `selectedPeriod`. 2. If the start date of `previousPeriod` is earlier than a year ago from the current date, it will be adjusted as follows:  `previousPeriod.start = current date - 365 days.`  #### Time Zones  IANA format, the current list can be viewed [here](https://nodatime.org/TimeZones). <br> <br> <br>   # noqa: E501

    OpenAPI spec version: 2.18
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NmReportGroupedResponseDataGroups(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'brand_name': 'str',
        'tags': 'list[NmReportDetailResponseDataTags]',
        'object': 'NmReportGroupedResponseDataObject',
        'statistics': 'NmReportGroupedResponseDataStatistics',
        'period_comparison': 'NmReportGroupedResponseDataPeriodComparison'
    }

    attribute_map = {
        'brand_name': 'brandName',
        'tags': 'tags',
        'object': 'object',
        'statistics': 'statistics',
        'period_comparison': 'periodComparison'
    }

    def __init__(self, brand_name=None, tags=None, object=None, statistics=None, period_comparison=None):  # noqa: E501
        """NmReportGroupedResponseDataGroups - a model defined in Swagger"""  # noqa: E501
        self._brand_name = None
        self._tags = None
        self._object = None
        self._statistics = None
        self._period_comparison = None
        self.discriminator = None
        if brand_name is not None:
            self.brand_name = brand_name
        if tags is not None:
            self.tags = tags
        if object is not None:
            self.object = object
        if statistics is not None:
            self.statistics = statistics
        if period_comparison is not None:
            self.period_comparison = period_comparison

    @property
    def brand_name(self):
        """Gets the brand_name of this NmReportGroupedResponseDataGroups.  # noqa: E501

        Brand name  # noqa: E501

        :return: The brand_name of this NmReportGroupedResponseDataGroups.  # noqa: E501
        :rtype: str
        """
        return self._brand_name

    @brand_name.setter
    def brand_name(self, brand_name):
        """Sets the brand_name of this NmReportGroupedResponseDataGroups.

        Brand name  # noqa: E501

        :param brand_name: The brand_name of this NmReportGroupedResponseDataGroups.  # noqa: E501
        :type: str
        """

        self._brand_name = brand_name

    @property
    def tags(self):
        """Gets the tags of this NmReportGroupedResponseDataGroups.  # noqa: E501


        :return: The tags of this NmReportGroupedResponseDataGroups.  # noqa: E501
        :rtype: list[NmReportDetailResponseDataTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this NmReportGroupedResponseDataGroups.


        :param tags: The tags of this NmReportGroupedResponseDataGroups.  # noqa: E501
        :type: list[NmReportDetailResponseDataTags]
        """

        self._tags = tags

    @property
    def object(self):
        """Gets the object of this NmReportGroupedResponseDataGroups.  # noqa: E501


        :return: The object of this NmReportGroupedResponseDataGroups.  # noqa: E501
        :rtype: NmReportGroupedResponseDataObject
        """
        return self._object

    @object.setter
    def object(self, object):
        """Sets the object of this NmReportGroupedResponseDataGroups.


        :param object: The object of this NmReportGroupedResponseDataGroups.  # noqa: E501
        :type: NmReportGroupedResponseDataObject
        """

        self._object = object

    @property
    def statistics(self):
        """Gets the statistics of this NmReportGroupedResponseDataGroups.  # noqa: E501


        :return: The statistics of this NmReportGroupedResponseDataGroups.  # noqa: E501
        :rtype: NmReportGroupedResponseDataStatistics
        """
        return self._statistics

    @statistics.setter
    def statistics(self, statistics):
        """Sets the statistics of this NmReportGroupedResponseDataGroups.


        :param statistics: The statistics of this NmReportGroupedResponseDataGroups.  # noqa: E501
        :type: NmReportGroupedResponseDataStatistics
        """

        self._statistics = statistics

    @property
    def period_comparison(self):
        """Gets the period_comparison of this NmReportGroupedResponseDataGroups.  # noqa: E501


        :return: The period_comparison of this NmReportGroupedResponseDataGroups.  # noqa: E501
        :rtype: NmReportGroupedResponseDataPeriodComparison
        """
        return self._period_comparison

    @period_comparison.setter
    def period_comparison(self, period_comparison):
        """Sets the period_comparison of this NmReportGroupedResponseDataGroups.


        :param period_comparison: The period_comparison of this NmReportGroupedResponseDataGroups.  # noqa: E501
        :type: NmReportGroupedResponseDataPeriodComparison
        """

        self._period_comparison = period_comparison

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NmReportGroupedResponseDataGroups, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NmReportGroupedResponseDataGroups):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
