# coding: utf-8

"""
    Seller API Analytics

    **The service provides a public API for obtaining analytical data.**  Analytical data in the source is stored for the past year. When selecting a start date earlier than a year ago, an error will be returned, so the maximum number of days in aggregations is 365.  Also, in the data where information about the previous period is provided: 1. In `previousPeriod`, the data is for the same period as in `selectedPeriod`. 2. If the start date of `previousPeriod` is earlier than a year ago from the current date, it will be adjusted as follows:  `previousPeriod.start = current date - 365 days.`  #### Time Zones  IANA format, the current list can be viewed [here](https://nodatime.org/TimeZones). <br> <br> <br>   # noqa: E501

    OpenAPI spec version: 2.18
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NmReportGroupedResponseDataStatistics(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'selected_period': 'NmReportGroupedResponseDataStatisticsSelectedPeriod',
        'previous_period': 'NmReportGroupedResponseDataStatisticsPreviousPeriod'
    }

    attribute_map = {
        'selected_period': 'selectedPeriod',
        'previous_period': 'previousPeriod'
    }

    def __init__(self, selected_period=None, previous_period=None):  # noqa: E501
        """NmReportGroupedResponseDataStatistics - a model defined in Swagger"""  # noqa: E501
        self._selected_period = None
        self._previous_period = None
        self.discriminator = None
        if selected_period is not None:
            self.selected_period = selected_period
        if previous_period is not None:
            self.previous_period = previous_period

    @property
    def selected_period(self):
        """Gets the selected_period of this NmReportGroupedResponseDataStatistics.  # noqa: E501


        :return: The selected_period of this NmReportGroupedResponseDataStatistics.  # noqa: E501
        :rtype: NmReportGroupedResponseDataStatisticsSelectedPeriod
        """
        return self._selected_period

    @selected_period.setter
    def selected_period(self, selected_period):
        """Sets the selected_period of this NmReportGroupedResponseDataStatistics.


        :param selected_period: The selected_period of this NmReportGroupedResponseDataStatistics.  # noqa: E501
        :type: NmReportGroupedResponseDataStatisticsSelectedPeriod
        """

        self._selected_period = selected_period

    @property
    def previous_period(self):
        """Gets the previous_period of this NmReportGroupedResponseDataStatistics.  # noqa: E501


        :return: The previous_period of this NmReportGroupedResponseDataStatistics.  # noqa: E501
        :rtype: NmReportGroupedResponseDataStatisticsPreviousPeriod
        """
        return self._previous_period

    @previous_period.setter
    def previous_period(self, previous_period):
        """Sets the previous_period of this NmReportGroupedResponseDataStatistics.


        :param previous_period: The previous_period of this NmReportGroupedResponseDataStatistics.  # noqa: E501
        :type: NmReportGroupedResponseDataStatisticsPreviousPeriod
        """

        self._previous_period = previous_period

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NmReportGroupedResponseDataStatistics, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NmReportGroupedResponseDataStatistics):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
